package config

import (
	"io/ioutil"

	yaml "gopkg.in/yaml.v2"
)

type Config struct {
	MetricsFrequency          int    `yaml:"metrics_frequency"`
	Origin                    string `yaml:"origin"`
	Password                  string `yaml:"password"`
	Username                  string `yaml:"username"`
	EmitLeaderFollowerMetrics bool   `yaml:"emit_leader_follower_metrics"`
}

func LoadFromFile(filepath string, object interface{}) error {
	contents, err := ioutil.ReadFile(filepath)
	if err != nil {
		return err
	}

	if err := yaml.Unmarshal(contents, object); err != nil {
		return err
	}

	return err
}
