package metrics

type MetricMappingConfig struct {
	MysqlMetricMappings          map[string]MysqlMetricMapping          `yaml:"mysql_metrics"`
	InternalMetricMappings       map[string]InternalMetricMapping       `yaml:"internal_metrics"`
	LeaderFollowerMetricMappings map[string]LeaderFollowerMetricMapping `yaml:"leader_follower_metrics"`
}

type MysqlMetricMapping struct {
	Key  string `yaml:"key"`
	Unit string `yaml:"unit"`
}

type InternalMetricMapping struct {
	Key string `yaml:"key"`
}

type LeaderFollowerMetricMapping struct {
	Key  string `yaml:"key"`
	Unit string `yaml:"unit"`
}

func (mc MetricMappingConfig) GetMysqlMetricMappings() map[string]MysqlMetricMapping {
	return mc.MysqlMetricMappings
}

func (mc MetricMappingConfig) GetInternalMetricMappings() map[string]InternalMetricMapping {
	return mc.InternalMetricMappings
}

func (mc MetricMappingConfig) GetLeaderFollowerMetricMappings() map[string]LeaderFollowerMetricMapping {
	return mc.LeaderFollowerMetricMappings
}
