// Code generated by counterfeiter. DO NOT EDIT.
package alertfakes

import (
	"sync"

	uaa_go_client "code.cloudfoundry.org/uaa-go-client"
	"code.cloudfoundry.org/uaa-go-client/schema"
)

type FakeUAAClient struct {
	FetchTokenStub        func(forceUpdate bool) (*schema.Token, error)
	fetchTokenMutex       sync.RWMutex
	fetchTokenArgsForCall []struct {
		forceUpdate bool
	}
	fetchTokenReturns struct {
		result1 *schema.Token
		result2 error
	}
	fetchTokenReturnsOnCall map[int]struct {
		result1 *schema.Token
		result2 error
	}
	FetchKeyStub        func() (string, error)
	fetchKeyMutex       sync.RWMutex
	fetchKeyArgsForCall []struct{}
	fetchKeyReturns     struct {
		result1 string
		result2 error
	}
	fetchKeyReturnsOnCall map[int]struct {
		result1 string
		result2 error
	}
	DecodeTokenStub        func(uaaToken string, desiredPermissions ...string) error
	decodeTokenMutex       sync.RWMutex
	decodeTokenArgsForCall []struct {
		uaaToken           string
		desiredPermissions []string
	}
	decodeTokenReturns struct {
		result1 error
	}
	decodeTokenReturnsOnCall map[int]struct {
		result1 error
	}
	RegisterOauthClientStub        func(*schema.OauthClient) (*schema.OauthClient, error)
	registerOauthClientMutex       sync.RWMutex
	registerOauthClientArgsForCall []struct {
		arg1 *schema.OauthClient
	}
	registerOauthClientReturns struct {
		result1 *schema.OauthClient
		result2 error
	}
	registerOauthClientReturnsOnCall map[int]struct {
		result1 *schema.OauthClient
		result2 error
	}
	FetchIssuerStub        func() (string, error)
	fetchIssuerMutex       sync.RWMutex
	fetchIssuerArgsForCall []struct{}
	fetchIssuerReturns     struct {
		result1 string
		result2 error
	}
	fetchIssuerReturnsOnCall map[int]struct {
		result1 string
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeUAAClient) FetchToken(forceUpdate bool) (*schema.Token, error) {
	fake.fetchTokenMutex.Lock()
	ret, specificReturn := fake.fetchTokenReturnsOnCall[len(fake.fetchTokenArgsForCall)]
	fake.fetchTokenArgsForCall = append(fake.fetchTokenArgsForCall, struct {
		forceUpdate bool
	}{forceUpdate})
	fake.recordInvocation("FetchToken", []interface{}{forceUpdate})
	fake.fetchTokenMutex.Unlock()
	if fake.FetchTokenStub != nil {
		return fake.FetchTokenStub(forceUpdate)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.fetchTokenReturns.result1, fake.fetchTokenReturns.result2
}

func (fake *FakeUAAClient) FetchTokenCallCount() int {
	fake.fetchTokenMutex.RLock()
	defer fake.fetchTokenMutex.RUnlock()
	return len(fake.fetchTokenArgsForCall)
}

func (fake *FakeUAAClient) FetchTokenArgsForCall(i int) bool {
	fake.fetchTokenMutex.RLock()
	defer fake.fetchTokenMutex.RUnlock()
	return fake.fetchTokenArgsForCall[i].forceUpdate
}

func (fake *FakeUAAClient) FetchTokenReturns(result1 *schema.Token, result2 error) {
	fake.FetchTokenStub = nil
	fake.fetchTokenReturns = struct {
		result1 *schema.Token
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) FetchTokenReturnsOnCall(i int, result1 *schema.Token, result2 error) {
	fake.FetchTokenStub = nil
	if fake.fetchTokenReturnsOnCall == nil {
		fake.fetchTokenReturnsOnCall = make(map[int]struct {
			result1 *schema.Token
			result2 error
		})
	}
	fake.fetchTokenReturnsOnCall[i] = struct {
		result1 *schema.Token
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) FetchKey() (string, error) {
	fake.fetchKeyMutex.Lock()
	ret, specificReturn := fake.fetchKeyReturnsOnCall[len(fake.fetchKeyArgsForCall)]
	fake.fetchKeyArgsForCall = append(fake.fetchKeyArgsForCall, struct{}{})
	fake.recordInvocation("FetchKey", []interface{}{})
	fake.fetchKeyMutex.Unlock()
	if fake.FetchKeyStub != nil {
		return fake.FetchKeyStub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.fetchKeyReturns.result1, fake.fetchKeyReturns.result2
}

func (fake *FakeUAAClient) FetchKeyCallCount() int {
	fake.fetchKeyMutex.RLock()
	defer fake.fetchKeyMutex.RUnlock()
	return len(fake.fetchKeyArgsForCall)
}

func (fake *FakeUAAClient) FetchKeyReturns(result1 string, result2 error) {
	fake.FetchKeyStub = nil
	fake.fetchKeyReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) FetchKeyReturnsOnCall(i int, result1 string, result2 error) {
	fake.FetchKeyStub = nil
	if fake.fetchKeyReturnsOnCall == nil {
		fake.fetchKeyReturnsOnCall = make(map[int]struct {
			result1 string
			result2 error
		})
	}
	fake.fetchKeyReturnsOnCall[i] = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) DecodeToken(uaaToken string, desiredPermissions ...string) error {
	fake.decodeTokenMutex.Lock()
	ret, specificReturn := fake.decodeTokenReturnsOnCall[len(fake.decodeTokenArgsForCall)]
	fake.decodeTokenArgsForCall = append(fake.decodeTokenArgsForCall, struct {
		uaaToken           string
		desiredPermissions []string
	}{uaaToken, desiredPermissions})
	fake.recordInvocation("DecodeToken", []interface{}{uaaToken, desiredPermissions})
	fake.decodeTokenMutex.Unlock()
	if fake.DecodeTokenStub != nil {
		return fake.DecodeTokenStub(uaaToken, desiredPermissions...)
	}
	if specificReturn {
		return ret.result1
	}
	return fake.decodeTokenReturns.result1
}

func (fake *FakeUAAClient) DecodeTokenCallCount() int {
	fake.decodeTokenMutex.RLock()
	defer fake.decodeTokenMutex.RUnlock()
	return len(fake.decodeTokenArgsForCall)
}

func (fake *FakeUAAClient) DecodeTokenArgsForCall(i int) (string, []string) {
	fake.decodeTokenMutex.RLock()
	defer fake.decodeTokenMutex.RUnlock()
	return fake.decodeTokenArgsForCall[i].uaaToken, fake.decodeTokenArgsForCall[i].desiredPermissions
}

func (fake *FakeUAAClient) DecodeTokenReturns(result1 error) {
	fake.DecodeTokenStub = nil
	fake.decodeTokenReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeUAAClient) DecodeTokenReturnsOnCall(i int, result1 error) {
	fake.DecodeTokenStub = nil
	if fake.decodeTokenReturnsOnCall == nil {
		fake.decodeTokenReturnsOnCall = make(map[int]struct {
			result1 error
		})
	}
	fake.decodeTokenReturnsOnCall[i] = struct {
		result1 error
	}{result1}
}

func (fake *FakeUAAClient) RegisterOauthClient(arg1 *schema.OauthClient) (*schema.OauthClient, error) {
	fake.registerOauthClientMutex.Lock()
	ret, specificReturn := fake.registerOauthClientReturnsOnCall[len(fake.registerOauthClientArgsForCall)]
	fake.registerOauthClientArgsForCall = append(fake.registerOauthClientArgsForCall, struct {
		arg1 *schema.OauthClient
	}{arg1})
	fake.recordInvocation("RegisterOauthClient", []interface{}{arg1})
	fake.registerOauthClientMutex.Unlock()
	if fake.RegisterOauthClientStub != nil {
		return fake.RegisterOauthClientStub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.registerOauthClientReturns.result1, fake.registerOauthClientReturns.result2
}

func (fake *FakeUAAClient) RegisterOauthClientCallCount() int {
	fake.registerOauthClientMutex.RLock()
	defer fake.registerOauthClientMutex.RUnlock()
	return len(fake.registerOauthClientArgsForCall)
}

func (fake *FakeUAAClient) RegisterOauthClientArgsForCall(i int) *schema.OauthClient {
	fake.registerOauthClientMutex.RLock()
	defer fake.registerOauthClientMutex.RUnlock()
	return fake.registerOauthClientArgsForCall[i].arg1
}

func (fake *FakeUAAClient) RegisterOauthClientReturns(result1 *schema.OauthClient, result2 error) {
	fake.RegisterOauthClientStub = nil
	fake.registerOauthClientReturns = struct {
		result1 *schema.OauthClient
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) RegisterOauthClientReturnsOnCall(i int, result1 *schema.OauthClient, result2 error) {
	fake.RegisterOauthClientStub = nil
	if fake.registerOauthClientReturnsOnCall == nil {
		fake.registerOauthClientReturnsOnCall = make(map[int]struct {
			result1 *schema.OauthClient
			result2 error
		})
	}
	fake.registerOauthClientReturnsOnCall[i] = struct {
		result1 *schema.OauthClient
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) FetchIssuer() (string, error) {
	fake.fetchIssuerMutex.Lock()
	ret, specificReturn := fake.fetchIssuerReturnsOnCall[len(fake.fetchIssuerArgsForCall)]
	fake.fetchIssuerArgsForCall = append(fake.fetchIssuerArgsForCall, struct{}{})
	fake.recordInvocation("FetchIssuer", []interface{}{})
	fake.fetchIssuerMutex.Unlock()
	if fake.FetchIssuerStub != nil {
		return fake.FetchIssuerStub()
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fake.fetchIssuerReturns.result1, fake.fetchIssuerReturns.result2
}

func (fake *FakeUAAClient) FetchIssuerCallCount() int {
	fake.fetchIssuerMutex.RLock()
	defer fake.fetchIssuerMutex.RUnlock()
	return len(fake.fetchIssuerArgsForCall)
}

func (fake *FakeUAAClient) FetchIssuerReturns(result1 string, result2 error) {
	fake.FetchIssuerStub = nil
	fake.fetchIssuerReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) FetchIssuerReturnsOnCall(i int, result1 string, result2 error) {
	fake.FetchIssuerStub = nil
	if fake.fetchIssuerReturnsOnCall == nil {
		fake.fetchIssuerReturnsOnCall = make(map[int]struct {
			result1 string
			result2 error
		})
	}
	fake.fetchIssuerReturnsOnCall[i] = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeUAAClient) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.fetchTokenMutex.RLock()
	defer fake.fetchTokenMutex.RUnlock()
	fake.fetchKeyMutex.RLock()
	defer fake.fetchKeyMutex.RUnlock()
	fake.decodeTokenMutex.RLock()
	defer fake.decodeTokenMutex.RUnlock()
	fake.registerOauthClientMutex.RLock()
	defer fake.registerOauthClientMutex.RUnlock()
	fake.fetchIssuerMutex.RLock()
	defer fake.fetchIssuerMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeUAAClient) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ uaa_go_client.Client = new(FakeUAAClient)
